diff --git a/@startuml b/@startuml
new file mode 100644
index 000000000..238e04290
--- /dev/null
+++ b/@startuml
@@ -0,0 +1,94 @@
+@startuml
+header Nuxeo Drive - Direct Transfer
+
+' uncomment the line below if you're using computer with a retina display
+' skinparam dpi 300
+!define Table(name,desc) class name as "desc" << (T,#FFAAAA) >>
+' we use bold for primary key
+' green color for unique
+' and underscore for not_null
+!define primary_key(x) <b>x</b>
+!define unique(x) <color:green>x</color>
+!define not_null(x) <u>x</u>
+hide methods
+hide stereotypes
+
+class Manager {
+    (The transfers manager)
+    ==
+    + sessions
+    + current_session
+    + decrease_priority()
+    + increase_priority()
+    + shutdown()
+    + start()
+    + stop()
+}
+
+class Session {
+    (A session manager)
+    ==
+    + transfers
+    + not_null(add())
+    + add_all()
+    + decrease_priority()
+    + increase_priority()
+}
+
+class UploadSession {
+    (An upload session manager)
+    ==
+    + func
+    + add()
+    + add_all()
+}
+
+class DownloadSession {
+    (A download session manager)
+    ==
+    + func
+    + add()
+    + add_all()
+}
+
+Manager::current_session --> Session
+Session --* DownloadSession
+Session --* UploadSession
+
+'
+'Table(Session, "Session\n(A transfers session)") {
+'    + primary_key(id) INTEGER
+'    + not_null(priority) INTEGER
+'    + not_null(state) INTEGER
+'    '.. termination status ..
+'    + not_null(status) INTEGER
+'    + finished DATETIME
+'    + remote_path VARCHAR
+'    + started DATETIME
+'}
+
+'Table(Transfer, "Transfer\n(An item to transfer)") {
+'    + primary_key(id) INTEGER
+'    + not_null(unique(session)) INTEGER
+'    + not_null(unique(local_path)) VARCHAR
+'    + not_null(unique(remote_path)) VARCHAR
+'    + error_count INTEGER
+'    + error_total_count INTEGER
+'    + last_error VARCHAR
+'    + file_size INTEGER
+'    + is_file BOOLEAN
+'    + is_upload BOOLEAN
+'    + remote_ref VARCHAR
+'    + status INTEGER
+'    + transferred_size INTEGER
+'    .. uploads only ..
+'    + batch VARCHAR
+'    + chunk_size INTEGER
+'    + doctype VARCHAR
+'    + replace_blob BOOLEAN
+'    + uploaded BOOLEAN
+'}
+
+'Manager::current_sesion --> Session::id
+'Session::id <-- Transfer::session
+@enduml
diff --git a/nxdrive/client/uploader/direct_transfer.py b/nxdrive/client/uploader/direct_transfer.py
index 27bbe84d3..f62bb47e8 100644
--- a/nxdrive/client/uploader/direct_transfer.py
+++ b/nxdrive/client/uploader/direct_transfer.py
@@ -9,10 +9,10 @@
 from nuxeo.models import Document
 
 from ...engine.activity import LinkingAction, UploadAction
-from ...exceptions import DirectTransferDuplicateFoundError
 from ...objects import Upload
 from ..local import LocalClient
 from . import BaseUploader
+from .exceptions import DirectTransferDuplicateFoundError
 
 log = getLogger(__name__)
 
diff --git a/nxdrive/direct_transfer/__init__.py b/nxdrive/direct_transfer/__init__.py
new file mode 100644
index 000000000..82d3b04c6
--- /dev/null
+++ b/nxdrive/direct_transfer/__init__.py
@@ -0,0 +1 @@
+"""The Direct Transfer feature."""
diff --git a/nxdrive/direct_transfer/adapters/notifications.py b/nxdrive/direct_transfer/adapters/notifications.py
new file mode 100644
index 000000000..a92ca2bb3
--- /dev/null
+++ b/nxdrive/direct_transfer/adapters/notifications.py
@@ -0,0 +1,7 @@
+import abc
+
+
+class AbstractNotifications(abc.ABC):
+    @abc.abstractmethod
+    def send(self, destination, message):
+        raise NotImplementedError
diff --git a/nxdrive/direct_transfer/adapters/orm.py b/nxdrive/direct_transfer/adapters/orm.py
new file mode 100644
index 000000000..98261211f
--- /dev/null
+++ b/nxdrive/direct_transfer/adapters/orm.py
@@ -0,0 +1,80 @@
+from logging import getLogger
+
+from sqlalchemy import (
+    Boolean,
+    Column,
+    Date,
+    Enum,
+    ForeignKey,
+    Integer,
+    JSON,
+    MetaData,
+    String,
+    Table,
+    Text,
+)
+from sqlalchemy.orm import mapper, relationship
+
+from ..domain import model
+from .. import constants
+
+log = getLogger(__name__)
+
+metadata = MetaData()
+
+transfer = Table(
+    "transfer",
+    metadata,
+    Column("uid", Integer, primary_key=True, autoincrement=True),
+    Column("state", Enum(constants.SessionState), default=constants.SessionState.DRAFT),
+    Column("priority", Integer, default=0),
+)
+
+# transfer_item = Table(
+#     "transfer_item",
+#     metadata,
+#     Column("uid", Integer, primary_key=True, autoincrement=True),
+#     Column("size", Integer),
+#     Column("is_file", Boolean),
+#     Column("transferred", Boolean),
+#     Column("state", Enum(constants.TransferStatus)),
+#     Column("remote_ref", Text),
+#     Column("remote_path", Text),
+#     Column("local_path", Text),
+#     Column("batch", JSON),
+#     Column("doctype", String(32)),
+# )
+
+# transfer_item_action = Table(
+#     "transfer_item_action",
+#     metadata,
+#     Column("uid", Integer, primary_key=True, autoincrement=True),
+#     Column("transfer_id", ForeignKey("transfer.uid")),
+#     Column("transfer_item_id", ForeignKey("transfer_item.uid")),
+#     Column("action", Enum(constants.TransferAction)),
+# )
+
+# transfer_item_error = Table(
+#     "transfer_item_error",
+#     metadata,
+#     Column("uid", Integer, primary_key=True, autoincrement=True),
+#     Column("transfer_item_id", ForeignKey("transfer_item.uid")),
+#     Column("error_count", Integer),
+#     Column("error_count_total", Integer),
+#     Column("last_error", Text),
+# )
+
+
+def start_mappers():
+    log.info("Starting mappers")
+    transfer_mapper = mapper(model.Transfer, transfer)
+    # transfer_item_mapper = mapper(
+    #     model.TransferItem,
+    #     transfer_item,
+    #     properties={"transfer": relationship(transfer_mapper)},
+    # )
+    # mapper(
+    #     model.TransferItemAction,
+    #     transfer_item_action,
+    #     properties={"transfer_item": relationship(transfer_item_mapper)},
+    # )
diff --git a/nxdrive/direct_transfer/adapters/qt_eventpublisher.py b/nxdrive/direct_transfer/adapters/qt_eventpublisher.py
new file mode 100644
index 000000000..8589cf77c
--- /dev/null
+++ b/nxdrive/direct_transfer/adapters/qt_eventpublisher.py
@@ -0,0 +1,12 @@
+import json
+from logging import getLogger
+from dataclasses import asdict
+
+from ..domain import events
+
+logger = getLogger(__name__)
+
+
+def publish(channel, event: events.Event):
+    logger.info("publishing: channel=%s, event=%s", channel, event)
+    # r.publish(channel, json.dumps(asdict(event)))
diff --git a/nxdrive/direct_transfer/adapters/repository.py b/nxdrive/direct_transfer/adapters/repository.py
new file mode 100644
index 000000000..07847af1e
--- /dev/null
+++ b/nxdrive/direct_transfer/adapters/repository.py
@@ -0,0 +1,58 @@
+import abc
+from typing import Set
+
+from ..adapters import orm
+from ..domain import model
+
+
+class AbstractRepository(abc.ABC):
+    def __init__(self):
+        self.seen: Set[model.Transfer] = set()
+
+    def add(self, transfer: model.Transfer):
+        self._add(transfer)
+        self.seen.add(transfer)
+
+    def get(self, uid) -> model.Transfer:
+        transfer = self._get(uid)
+        if transfer:
+            self.seen.add(transfer)
+        return transfer
+
+    def get_by_batchref(self, batchref) -> model.Transfer:
+        transfer = self._get_by_batchref(batchref)
+        if transfer:
+            self.seen.add(transfer)
+        return transfer
+
+    @abc.abstractmethod
+    def _add(self, transfer: model.Transfer):
+        raise NotImplementedError
+
+    @abc.abstractmethod
+    def _get(self, uid) -> model.Transfer:
+        raise NotImplementedError
+
+    @abc.abstractmethod
+    def _get_by_batchref(self, batchref) -> model.Transfer:
+        raise NotImplementedError
+
+
+class SqlAlchemyRepository(AbstractRepository):
+    def __init__(self, session):
+        super().__init__()
+        self.session = session
+
+    def _add(self, transfer):
+        self.session.add(transfer)
+
+    def _get(self, uid: int):
+        return self.session.query(model.Transfer).filter_by(uid=uid).first()
+
+    def _get_by_batchref(self, batchref):
+        return (
+            self.session.query(model.Transfer)
+            .join(model.Batch)
+            .filter(orm.batches.c.reference == batchref,)
+            .first()
+        )
diff --git a/nxdrive/direct_transfer/bootstrap.py b/nxdrive/direct_transfer/bootstrap.py
new file mode 100644
index 000000000..4b50c568a
--- /dev/null
+++ b/nxdrive/direct_transfer/bootstrap.py
@@ -0,0 +1,43 @@
+import inspect
+from typing import Callable
+
+from .adapters import orm, qt_eventpublisher
+from .adapters.notifications import AbstractNotifications
+from .service_layer import handlers, messagebus, unit_of_work
+
+
+def bootstrap(
+    start_orm: bool = True,
+    uow: unit_of_work.AbstractUnitOfWork = unit_of_work.SqlAlchemyUnitOfWork(),
+    notifications: AbstractNotifications = None,
+    publish: Callable = qt_eventpublisher.publish,
+) -> messagebus.MessageBus:
+
+    if start_orm:
+        orm.start_mappers()
+
+    dependencies = {"uow": uow, "notifications": notifications, "publish": publish}
+    injected_event_handlers = {
+        event_type: [
+            inject_dependencies(handler, dependencies) for handler in event_handlers
+        ]
+        for event_type, event_handlers in handlers.EVENT_HANDLERS.items()
+    }
+    injected_command_handlers = {
+        command_type: inject_dependencies(handler, dependencies)
+        for command_type, handler in handlers.COMMAND_HANDLERS.items()
+    }
+
+    return messagebus.MessageBus(
+        uow=uow,
+        event_handlers=injected_event_handlers,
+        command_handlers=injected_command_handlers,
+    )
+
+
+def inject_dependencies(handler, dependencies):
+    params = inspect.signature(handler).parameters
+    deps = {
+        name: dependency for name, dependency in dependencies.items() if name in params
+    }
+    return lambda message: handler(message, **deps)
diff --git a/nxdrive/direct_transfer/constants.py b/nxdrive/direct_transfer/constants.py
new file mode 100644
index 000000000..573eb66be
--- /dev/null
+++ b/nxdrive/direct_transfer/constants.py
@@ -0,0 +1,46 @@
+"""
+The Direct Transfer feature.
+
+What: constants.
+"""
+
+from enum import Enum
+
+
+class TransferAction(Enum):
+    """Represent a session state."""
+
+    DOWNLOAD = "DOWN"
+    UPLOAD = "UP"
+    REPLACE_BLOB = "REPLACE"
+
+
+class SessionState(Enum):
+    """Represent a session state."""
+
+    DRAFT = 0
+    PENDING = 1
+    RUNNING = 2
+    SUSPENDED = 3
+    ON_HOLD = 4
+    ENDED = 5
+
+
+class SessionTerminationStatus(Enum):
+    """Represent a session final status."""
+
+    NONE = 0
+    SUCCESS = 1
+    FAILURE = 2
+    CANCELLED = 3
+
+
+class TransferStatus(Enum):
+    """Represent a single item transfer status."""
+
+    NONE = 0
+    ONGOING = 1
+    PAUSED = 2
+    SUSPENDED = 3
+    DONE = 4
+    ABORTED = 5
diff --git a/nxdrive/direct_transfer/domain/commands.py b/nxdrive/direct_transfer/domain/commands.py
new file mode 100644
index 000000000..42fb16e89
--- /dev/null
+++ b/nxdrive/direct_transfer/domain/commands.py
@@ -0,0 +1,30 @@
+from dataclasses import dataclass
+
+
+class Command:
+    pass
+
+
+@dataclass
+class Cancel(Command):
+    uid: int
+
+
+@dataclass
+class Force(Command):
+    uid: int
+
+
+@dataclass
+class Pause(Command):
+    uid: int
+
+
+@dataclass
+class Resume(Command):
+    uid: int
+
+
+@dataclass
+class Transfer(Command):
+    uid: int
diff --git a/nxdrive/direct_transfer/domain/events.py b/nxdrive/direct_transfer/domain/events.py
new file mode 100644
index 000000000..0dda01b96
--- /dev/null
+++ b/nxdrive/direct_transfer/domain/events.py
@@ -0,0 +1,46 @@
+from dataclasses import dataclass
+
+
+class Event:
+    pass
+
+
+@dataclass
+class Added(Event):
+    uid: int
+
+
+@dataclass
+class Cancelled(Event):
+    uid: int
+
+
+@dataclass
+class ChunkSent(Event):
+    uid: int
+
+
+@dataclass
+class Done(Event):
+    uid: int
+
+
+@dataclass
+class Paused(Event):
+    uid: int
+
+
+@dataclass
+class Removed(Event):
+    uid: int
+
+
+@dataclass
+class Resumed(Event):
+    uid: int
+
+
+@dataclass
+class TransferError(Event):
+    uid: int
+    error: str
diff --git a/nxdrive/direct_transfer/domain/model.py b/nxdrive/direct_transfer/domain/model.py
new file mode 100644
index 000000000..283f45dc5
--- /dev/null
+++ b/nxdrive/direct_transfer/domain/model.py
@@ -0,0 +1,84 @@
+from dataclasses import dataclass, field
+from typing import Any, Dict, List, Optional, Set
+
+from ..domain import events
+from ..constants import SessionState, SessionTerminationStatus
+
+
+@dataclass(unsafe_hash=True)
+class TransferItem:
+    uid: int
+    local_path: str
+    is_file: Optional[bool] = field(default=True, hash=False)
+    size: Optional[bool] = field(default=0, hash=False)
+    transferred: Optional[bool] = field(default=False, hash=False)
+    status: Optional[int] = field(default=SessionState.DRAFT, hash=False)
+    remote_ref: Optional[str] = field(default="", hash=False)
+    remote_path: Optional[str] = field(default="", hash=False)
+    batch: Optional[Dict[str, Any]] = field(default_factory=dict, hash=False)
+
+    def transferred_size(self) -> int:
+        if self.transferred:
+            return self.size
+        return 0
+
+
+class Transfer:
+    def __init__(
+        self,
+        uid: str,
+        state: Optional[SessionState] = SessionState.DRAFT,
+        priority: Optional[int] = 0,
+    ):
+        self.uid = uid
+        self.state = state
+        self.priority = priority
+        self._items: Set[TransferItem] = set()
+        self.events: List[events.Event] = []
+
+    def __repr__(self) -> str:
+        return f"Transfer(uid={self.uid}, priority={self.priority})"
+
+    def __eq__(self, other) -> bool:
+        if not isinstance(other, Transfer):
+            return False
+        return other.uid == self.uid
+
+    def __hash__(self) -> int:
+        return hash(self.uid)
+
+    def __gt__(self, other) -> bool:
+        return self.priority > other.priority or self.uid > other.uid
+
+    @property
+    def status(self) -> SessionTerminationStatus:
+        if self.state is not SessionState.ENDED:
+            return SessionTerminationStatus.NONE
+        if all(item.transferred for item in self._items):
+            return SessionTerminationStatus.SUCCESS
+        return SessionTerminationStatus.FAILURE
+
+    def add(self, item: TransferItem) -> None:
+        self._items.add(item)
+        self.events.append(events.Added(item.uid))
+
+    def remove(self, item: TransferItem) -> None:
+        self._items.remove(item)
+        self.events.append(events.Removed(item.uid))
+
+
+@dataclass(frozen=True)
+class TransferItemAction:
+    uid: int
+    transfer_id: int
+    transfer_item_id: int
+    action: str
+
+
+@dataclass(frozen=True)
+class TransferItemError:
+    uid: int
+    transfer_item_id: int
+    error_count: int
+    error_count_total: int
+    last_error: str
diff --git a/nxdrive/direct_transfer/manager.py b/nxdrive/direct_transfer/manager.py
new file mode 100644
index 000000000..e9f4a7c05
--- /dev/null
+++ b/nxdrive/direct_transfer/manager.py
@@ -0,0 +1,63 @@
+"""
+The Direct Transfer feature.
+
+What: the transfers manager.
+
+For now, transfers are done in sequence as it eases the implementation.
+For better performances, one should really use Nuxeo Drive.
+"""
+from logging import getLogger
+from pathlib import Path
+from typing import TYPE_CHECKING, Callable
+
+from . import bootstrap
+
+if TYPE_CHECKING:
+    from nuxeo.handlers.default import Uploader  # noqa
+    from nuxeo.models import Document  # noqa
+
+    from .client.remote_client import Remote  # noqa
+
+
+log = getLogger(__name__)
+
+
+class DirectTransferManager:
+    """Direct Transfer manager.
+    This is the core of the feature, separated from Nuxeo Drive.
+    It is used to create a new Direct Transfer, keep track of the progression,
+    pause/resume transfers and it is connected to a (beautiful) custom QML component.
+    """
+
+    def __init__(
+        self,
+        db: str,
+        engine_uid: str,
+        remote: "Remote",
+        chunk_callback: Callable[["Uploader"], None] = lambda *_: None,
+        done_callback: Callable[[bool, int], None] = lambda *_: None,
+        dupe_callback: Callable[[Path, "Document"], None] = lambda *_: None,
+    ) -> None:
+        """
+        *chunk_callback* is triggered when a chunk is successfully transferred.
+        *done_callback* is triggered when a transfer was successfully done.
+        *dupe_callback* is triggered when a given upload would generate a duplicate on the server.
+        """
+        self.db = db
+        self.engine_uid = engine_uid
+        self.remote = remote
+        self.chunk_callback = chunk_callback
+        self.done_callback = done_callback
+        self.dupe_callback = dupe_callback
+
+        self.bus = bootstrap.bootstrap()
+
+    def __repr__(self) -> str:
+        return (
+            f"{type(self).__name__}<uid={self.engine_uid!r}"
+            f", started={self.is_started!r}"
+            f", sessions={len(self.sessions)}"
+            f", session={self.current_session}"
+            f", db={self.db!r}"
+            ">"
+        )
diff --git a/nxdrive/direct_transfer/runner.py b/nxdrive/direct_transfer/runner.py
new file mode 100644
index 000000000..5b93b8def
--- /dev/null
+++ b/nxdrive/direct_transfer/runner.py
@@ -0,0 +1,27 @@
+"""
+The Direct Transfer feature.
+
+What: threaded runner.
+"""
+from threading import Thread
+from typing import Any, Optional
+
+
+class Runner(Thread):
+    """Simple runner used for every single upload.
+    Any exception will be forwarded to the caller via the .error attribute.
+    """
+
+    def __init__(self, *args: Any, **kwargs: Any) -> None:
+        """Simple init to declare .error that is used to communicate eventual exceptions to the caller."""
+        super().__init__(*args, **kwargs)
+        self.error: Optional[Exception] = None
+
+    def run(self) -> None:
+        """Catch any error and store it inside the .error attribute instead of throwing it."""
+        try:
+            super().run()
+        except Exception as exc:
+            self.error = exc
+            # Break reference cyle
+            exc = None  # type: ignore
diff --git a/nxdrive/direct_transfer/service_layer/handlers.py b/nxdrive/direct_transfer/service_layer/handlers.py
new file mode 100644
index 000000000..9a8aaf214
--- /dev/null
+++ b/nxdrive/direct_transfer/service_layer/handlers.py
@@ -0,0 +1,107 @@
+from typing import Callable, Dict, List, Type
+from pathlib import Path
+
+from nuxeo.models import Document
+
+from . import unit_of_work
+from ..adapters import notifications
+from ..domain import commands, events
+
+
+class DirectTransferPaused(Exception):
+    """A transfer has been paused, the file's processing should stop."""
+
+
+class DirectTransferDuplicateFoundError(ValueError):
+    """
+    Exception raised when a duplicate file already exists on the server
+    and trying to Direct Transfer a local file with the same name.
+    """
+
+    def __init__(self, file: Path, doc: Document) -> None:
+        self.file = file
+        self.doc = doc
+
+    def __repr__(self) -> str:
+        return f"{type(self).__name__}<file={self.file!r}, doc={self.doc!r}>"
+
+    def __str__(self) -> str:
+        return (
+            f"Document with the name {self.file.name!r} already found on the server: {self.doc}."
+            f"Direct Transfer of {self.file!r} postponed after the user decided what to do."
+        )
+
+
+#
+# Events
+#
+
+
+def chunk_sent(
+    event: events.ChunkSent, notifications: notifications.AbstractNotifications
+):
+    pass
+
+
+def send_transfer_error_notification(
+    event: events.TransferError, notifications: notifications.AbstractNotifications
+):
+    pass
+
+
+def transfer_cancelled(event: events.Cancelled, publish: Callable):
+    pass
+
+
+def transfer_done(event: events.Done, publish: Callable):
+    pass
+
+
+def transfer_paused(event: events.Paused, publish: Callable):
+    pass
+
+
+def transfer_resumed(event: events.Resumed, publish: Callable):
+    pass
+
+
+#
+# Commands
+#
+
+
+def cancel(cmd: commands.Cancel, uow: unit_of_work.AbstractUnitOfWork):
+    pass
+
+
+def force_transfer(cmd: commands.Force, uow: unit_of_work.AbstractUnitOfWork):
+    pass
+
+
+def pause_transfer(cmd: commands.Pause, uow: unit_of_work.AbstractUnitOfWork):
+    pass
+
+
+def resume_transfer(cmd: commands.Resume, uow: unit_of_work.AbstractUnitOfWork):
+    pass
+
+
+def transfer(cmd: commands.Transfer, uow: unit_of_work.AbstractUnitOfWork):
+    pass
+
+
+EVENT_HANDLERS: Dict[Type[events.Event], List[Callable]] = {
+    events.Cancelled: [transfer_cancelled],
+    events.Done: [transfer_done],
+    events.Paused: [transfer_paused],
+    events.Resumed: [transfer_resumed],
+    events.TransferError: [send_transfer_error_notification],
+}
+
+COMMAND_HANDLERS: Dict[Type[commands.Command], Callable] = {
+    commands.Cancel: cancel,
+    commands.Force: force_transfer,
+    commands.Pause: pause_transfer,
+    commands.Resume: resume_transfer,
+    commands.Transfer: transfer,
+}
diff --git a/nxdrive/direct_transfer/service_layer/messagebus.py b/nxdrive/direct_transfer/service_layer/messagebus.py
new file mode 100644
index 000000000..d201111c9
--- /dev/null
+++ b/nxdrive/direct_transfer/service_layer/messagebus.py
@@ -0,0 +1,52 @@
+from logging import getLogger
+from typing import Callable, Dict, List, Union, Type
+
+from ..domain import commands, events
+from ..service_layer import unit_of_work
+
+logger = getLogger(__name__)
+
+Message = Union[commands.Command, events.Event]
+
+
+class MessageBus:
+    def __init__(
+        self,
+        uow: unit_of_work.AbstractUnitOfWork,
+        event_handlers: Dict[Type[events.Event], List[Callable]],
+        command_handlers: Dict[Type[commands.Command], Callable],
+    ):
+        self.uow = uow
+        self.event_handlers = event_handlers
+        self.command_handlers = command_handlers
+
+    def handle(self, message: Message):
+        self.queue = [message]
+        while self.queue:
+            message = self.queue.pop(0)
+            if isinstance(message, events.Event):
+                self.handle_event(message)
+            elif isinstance(message, commands.Command):
+                self.handle_command(message)
+            else:
+                raise Exception(f"{message} was not an Event or Command")
+
+    def handle_event(self, event: events.Event):
+        for handler in self.event_handlers[type(event)]:
+            try:
+                logger.debug("handling event %s with handler %s", event, handler)
+                handler(event)
+                self.queue.extend(self.uow.collect_new_events())
+            except Exception:
+                logger.exception("Exception handling event %s", event)
+                continue
+
+    def handle_command(self, command: commands.Command):
+        logger.debug("handling command %s", command)
+        try:
+            handler = self.command_handlers[type(command)]
+            handler(command)
+            self.queue.extend(self.uow.collect_new_events())
+        except Exception:
+            logger.exception("Exception handling command %s", command)
+            raise
diff --git a/nxdrive/direct_transfer/service_layer/unit_of_work.py b/nxdrive/direct_transfer/service_layer/unit_of_work.py
new file mode 100644
index 000000000..76bd7b485
--- /dev/null
+++ b/nxdrive/direct_transfer/service_layer/unit_of_work.py
@@ -0,0 +1,57 @@
+import abc
+from sqlalchemy import create_engine
+from sqlalchemy.orm import sessionmaker
+from sqlalchemy.orm.session import Session
+
+from ..adapters import repository
+
+
+class AbstractUnitOfWork(abc.ABC):
+    products: repository.AbstractRepository
+
+    def __enter__(self) -> "AbstractUnitOfWork":
+        return self
+
+    def __exit__(self, *args):
+        self.rollback()
+
+    def commit(self):
+        self._commit()
+
+    def collect_new_events(self):
+        for product in self.products.seen:
+            while product.events:
+                yield product.events.pop(0)
+
+    @abc.abstractmethod
+    def _commit(self):
+        raise NotImplementedError
+
+    @abc.abstractmethod
+    def rollback(self):
+        raise NotImplementedError
+
+
+class SqlAlchemyUnitOfWork(AbstractUnitOfWork):
+    def __init__(self, session_factory=None):
+        if session_factory is None:
+            self.session_factory = sessionmaker(
+                bind=create_engine("sqlite:///:memory:"),
+            )
+        else:
+            self.session_factory: Session = session_factory
+
+    def __enter__(self):
+        self.session = self.session_factory()
+        self.products = repository.SqlAlchemyRepository(self.session)
+        return super().__enter__()
+
+    def __exit__(self, *args):
+        super().__exit__(*args)
+        self.session.close()
+
+    def _commit(self):
+        self.session.commit()
+
+    def rollback(self):
+        self.session.rollback()
